"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.DELEGATE_TOKEN_ACCOUNT_DISCRIMINATOR = void 0;
exports.getDelegateTokenAccountDiscriminatorBytes = getDelegateTokenAccountDiscriminatorBytes;
exports.getDelegateTokenAccountInstructionDataEncoder = getDelegateTokenAccountInstructionDataEncoder;
exports.getDelegateTokenAccountInstructionDataDecoder = getDelegateTokenAccountInstructionDataDecoder;
exports.getDelegateTokenAccountInstructionDataCodec = getDelegateTokenAccountInstructionDataCodec;
exports.getDelegateTokenAccountInstruction = getDelegateTokenAccountInstruction;
exports.parseDelegateTokenAccountInstruction = parseDelegateTokenAccountInstruction;
const web3_js_1 = require("solana2": "npm:@solana/web3.js@^2.0.0");
const programs_1 = require("../programs");
const shared_1 = require("../shared");
exports.DELEGATE_TOKEN_ACCOUNT_DISCRIMINATOR = 20;
function getDelegateTokenAccountDiscriminatorBytes() {
    return (0, web3_js_1.getU8Encoder)().encode(exports.DELEGATE_TOKEN_ACCOUNT_DISCRIMINATOR);
}
function getDelegateTokenAccountInstructionDataEncoder() {
    return (0, web3_js_1.transformEncoder)((0, web3_js_1.getStructEncoder)([['discriminator', (0, web3_js_1.getU8Encoder)()]]), (value) => ({
        ...value,
        discriminator: exports.DELEGATE_TOKEN_ACCOUNT_DISCRIMINATOR,
    }));
}
function getDelegateTokenAccountInstructionDataDecoder() {
    return (0, web3_js_1.getStructDecoder)([['discriminator', (0, web3_js_1.getU8Decoder)()]]);
}
function getDelegateTokenAccountInstructionDataCodec() {
    return (0, web3_js_1.combineCodec)(getDelegateTokenAccountInstructionDataEncoder(), getDelegateTokenAccountInstructionDataDecoder());
}
function getDelegateTokenAccountInstruction(input) {
    // Program address.
    const programAddress = programs_1.JITO_VAULT_PROGRAM_ADDRESS;
    // Original accounts.
    const originalAccounts = {
        config: { value: input.config ?? null, isWritable: false },
        vault: { value: input.vault ?? null, isWritable: false },
        delegateAssetAdmin: {
            value: input.delegateAssetAdmin ?? null,
            isWritable: false,
        },
        tokenMint: { value: input.tokenMint ?? null, isWritable: false },
        tokenAccount: { value: input.tokenAccount ?? null, isWritable: true },
        delegate: { value: input.delegate ?? null, isWritable: false },
        tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
    };
    const accounts = originalAccounts;
    // Resolve default values.
    if (!accounts.tokenProgram.value) {
        accounts.tokenProgram.value =
            'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA';
    }
    const getAccountMeta = (0, shared_1.getAccountMetaFactory)(programAddress, 'programId');
    const instruction = {
        accounts: [
            getAccountMeta(accounts.config),
            getAccountMeta(accounts.vault),
            getAccountMeta(accounts.delegateAssetAdmin),
            getAccountMeta(accounts.tokenMint),
            getAccountMeta(accounts.tokenAccount),
            getAccountMeta(accounts.delegate),
            getAccountMeta(accounts.tokenProgram),
        ],
        programAddress,
        data: getDelegateTokenAccountInstructionDataEncoder().encode({}),
    };
    return instruction;
}
function parseDelegateTokenAccountInstruction(instruction) {
    if (instruction.accounts.length < 7) {
        // TODO: Coded error.
        throw new Error('Not enough accounts');
    }
    let accountIndex = 0;
    const getNextAccount = () => {
        const accountMeta = instruction.accounts[accountIndex];
        accountIndex += 1;
        return accountMeta;
    };
    return {
        programAddress: instruction.programAddress,
        accounts: {
            config: getNextAccount(),
            vault: getNextAccount(),
            delegateAssetAdmin: getNextAccount(),
            tokenMint: getNextAccount(),
            tokenAccount: getNextAccount(),
            delegate: getNextAccount(),
            tokenProgram: getNextAccount(),
        },
        data: getDelegateTokenAccountInstructionDataDecoder().decode(instruction.data),
    };
}
//# sourceMappingURL=delegateTokenAccount.js.map