/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from'solana2';
import { JITO_VAULT_PROGRAM_ADDRESS } from '../programs';
export declare const ENQUEUE_WITHDRAWAL_DISCRIMINATOR = 12;
export declare function getEnqueueWithdrawalDiscriminatorBytes(): import("solana2": "npm:@solana/web3.js@^2.0.0").ReadonlyUint8Array;
export type EnqueueWithdrawalInstruction<TProgram extends string = typeof JITO_VAULT_PROGRAM_ADDRESS, TAccountConfig extends string | IAccountMeta<string> = string, TAccountVault extends string | IAccountMeta<string> = string, TAccountVaultStakerWithdrawalTicket extends string | IAccountMeta<string> = string, TAccountVaultStakerWithdrawalTicketTokenAccount extends string | IAccountMeta<string> = string, TAccountStaker extends string | IAccountMeta<string> = string, TAccountStakerVrtTokenAccount extends string | IAccountMeta<string> = string, TAccountBase extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountBurnSigner extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountConfig extends string ? ReadonlyAccount<TAccountConfig> : TAccountConfig,
    TAccountVault extends string ? WritableAccount<TAccountVault> : TAccountVault,
    TAccountVaultStakerWithdrawalTicket extends string ? WritableAccount<TAccountVaultStakerWithdrawalTicket> : TAccountVaultStakerWithdrawalTicket,
    TAccountVaultStakerWithdrawalTicketTokenAccount extends string ? WritableAccount<TAccountVaultStakerWithdrawalTicketTokenAccount> : TAccountVaultStakerWithdrawalTicketTokenAccount,
    TAccountStaker extends string ? WritableSignerAccount<TAccountStaker> & IAccountSignerMeta<TAccountStaker> : TAccountStaker,
    TAccountStakerVrtTokenAccount extends string ? WritableAccount<TAccountStakerVrtTokenAccount> : TAccountStakerVrtTokenAccount,
    TAccountBase extends string ? ReadonlySignerAccount<TAccountBase> & IAccountSignerMeta<TAccountBase> : TAccountBase,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountBurnSigner extends string ? ReadonlySignerAccount<TAccountBurnSigner> & IAccountSignerMeta<TAccountBurnSigner> : TAccountBurnSigner,
    ...TRemainingAccounts
]>;
export type EnqueueWithdrawalInstructionData = {
    discriminator: number;
    amount: bigint;
};
export type EnqueueWithdrawalInstructionDataArgs = {
    amount: number | bigint;
};
export declare function getEnqueueWithdrawalInstructionDataEncoder(): Encoder<EnqueueWithdrawalInstructionDataArgs>;
export declare function getEnqueueWithdrawalInstructionDataDecoder(): Decoder<EnqueueWithdrawalInstructionData>;
export declare function getEnqueueWithdrawalInstructionDataCodec(): Codec<EnqueueWithdrawalInstructionDataArgs, EnqueueWithdrawalInstructionData>;
export type EnqueueWithdrawalInput<TAccountConfig extends string = string, TAccountVault extends string = string, TAccountVaultStakerWithdrawalTicket extends string = string, TAccountVaultStakerWithdrawalTicketTokenAccount extends string = string, TAccountStaker extends string = string, TAccountStakerVrtTokenAccount extends string = string, TAccountBase extends string = string, TAccountTokenProgram extends string = string, TAccountSystemProgram extends string = string, TAccountBurnSigner extends string = string> = {
    config: Address<TAccountConfig>;
    vault: Address<TAccountVault>;
    vaultStakerWithdrawalTicket: Address<TAccountVaultStakerWithdrawalTicket>;
    vaultStakerWithdrawalTicketTokenAccount: Address<TAccountVaultStakerWithdrawalTicketTokenAccount>;
    staker: TransactionSigner<TAccountStaker>;
    stakerVrtTokenAccount: Address<TAccountStakerVrtTokenAccount>;
    base: TransactionSigner<TAccountBase>;
    tokenProgram?: Address<TAccountTokenProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    /** Signer for burning */
    burnSigner?: TransactionSigner<TAccountBurnSigner>;
    amount: EnqueueWithdrawalInstructionDataArgs['amount'];
};
export declare function getEnqueueWithdrawalInstruction<TAccountConfig extends string, TAccountVault extends string, TAccountVaultStakerWithdrawalTicket extends string, TAccountVaultStakerWithdrawalTicketTokenAccount extends string, TAccountStaker extends string, TAccountStakerVrtTokenAccount extends string, TAccountBase extends string, TAccountTokenProgram extends string, TAccountSystemProgram extends string, TAccountBurnSigner extends string>(input: EnqueueWithdrawalInput<TAccountConfig, TAccountVault, TAccountVaultStakerWithdrawalTicket, TAccountVaultStakerWithdrawalTicketTokenAccount, TAccountStaker, TAccountStakerVrtTokenAccount, TAccountBase, TAccountTokenProgram, TAccountSystemProgram, TAccountBurnSigner>): EnqueueWithdrawalInstruction<typeof JITO_VAULT_PROGRAM_ADDRESS, TAccountConfig, TAccountVault, TAccountVaultStakerWithdrawalTicket, TAccountVaultStakerWithdrawalTicketTokenAccount, TAccountStaker, TAccountStakerVrtTokenAccount, TAccountBase, TAccountTokenProgram, TAccountSystemProgram, TAccountBurnSigner>;
export type ParsedEnqueueWithdrawalInstruction<TProgram extends string = typeof JITO_VAULT_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        config: TAccountMetas[0];
        vault: TAccountMetas[1];
        vaultStakerWithdrawalTicket: TAccountMetas[2];
        vaultStakerWithdrawalTicketTokenAccount: TAccountMetas[3];
        staker: TAccountMetas[4];
        stakerVrtTokenAccount: TAccountMetas[5];
        base: TAccountMetas[6];
        tokenProgram: TAccountMetas[7];
        systemProgram: TAccountMetas[8];
        /** Signer for burning */
        burnSigner?: TAccountMetas[9] | undefined;
    };
    data: EnqueueWithdrawalInstructionData;
};
export declare function parseEnqueueWithdrawalInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedEnqueueWithdrawalInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=enqueueWithdrawal.d.ts.map