"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.ENQUEUE_WITHDRAWAL_DISCRIMINATOR = void 0;
exports.getEnqueueWithdrawalDiscriminatorBytes = getEnqueueWithdrawalDiscriminatorBytes;
exports.getEnqueueWithdrawalInstructionDataEncoder = getEnqueueWithdrawalInstructionDataEncoder;
exports.getEnqueueWithdrawalInstructionDataDecoder = getEnqueueWithdrawalInstructionDataDecoder;
exports.getEnqueueWithdrawalInstructionDataCodec = getEnqueueWithdrawalInstructionDataCodec;
exports.getEnqueueWithdrawalInstruction = getEnqueueWithdrawalInstruction;
exports.parseEnqueueWithdrawalInstruction = parseEnqueueWithdrawalInstruction;
const web3_js_1 = require("solana2": "npm:@solana/web3.js@^2.0.0");
const programs_1 = require("../programs");
const shared_1 = require("../shared");
exports.ENQUEUE_WITHDRAWAL_DISCRIMINATOR = 12;
function getEnqueueWithdrawalDiscriminatorBytes() {
    return (0, web3_js_1.getU8Encoder)().encode(exports.ENQUEUE_WITHDRAWAL_DISCRIMINATOR);
}
function getEnqueueWithdrawalInstructionDataEncoder() {
    return (0, web3_js_1.transformEncoder)((0, web3_js_1.getStructEncoder)([
        ['discriminator', (0, web3_js_1.getU8Encoder)()],
        ['amount', (0, web3_js_1.getU64Encoder)()],
    ]), (value) => ({ ...value, discriminator: exports.ENQUEUE_WITHDRAWAL_DISCRIMINATOR }));
}
function getEnqueueWithdrawalInstructionDataDecoder() {
    return (0, web3_js_1.getStructDecoder)([
        ['discriminator', (0, web3_js_1.getU8Decoder)()],
        ['amount', (0, web3_js_1.getU64Decoder)()],
    ]);
}
function getEnqueueWithdrawalInstructionDataCodec() {
    return (0, web3_js_1.combineCodec)(getEnqueueWithdrawalInstructionDataEncoder(), getEnqueueWithdrawalInstructionDataDecoder());
}
function getEnqueueWithdrawalInstruction(input) {
    // Program address.
    const programAddress = programs_1.JITO_VAULT_PROGRAM_ADDRESS;
    // Original accounts.
    const originalAccounts = {
        config: { value: input.config ?? null, isWritable: false },
        vault: { value: input.vault ?? null, isWritable: true },
        vaultStakerWithdrawalTicket: {
            value: input.vaultStakerWithdrawalTicket ?? null,
            isWritable: true,
        },
        vaultStakerWithdrawalTicketTokenAccount: {
            value: input.vaultStakerWithdrawalTicketTokenAccount ?? null,
            isWritable: true,
        },
        staker: { value: input.staker ?? null, isWritable: true },
        stakerVrtTokenAccount: {
            value: input.stakerVrtTokenAccount ?? null,
            isWritable: true,
        },
        base: { value: input.base ?? null, isWritable: false },
        tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
        systemProgram: { value: input.systemProgram ?? null, isWritable: false },
        burnSigner: { value: input.burnSigner ?? null, isWritable: false },
    };
    const accounts = originalAccounts;
    // Original args.
    const args = { ...input };
    // Resolve default values.
    if (!accounts.tokenProgram.value) {
        accounts.tokenProgram.value =
            'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA';
    }
    if (!accounts.systemProgram.value) {
        accounts.systemProgram.value =
            '11111111111111111111111111111111';
    }
    const getAccountMeta = (0, shared_1.getAccountMetaFactory)(programAddress, 'programId');
    const instruction = {
        accounts: [
            getAccountMeta(accounts.config),
            getAccountMeta(accounts.vault),
            getAccountMeta(accounts.vaultStakerWithdrawalTicket),
            getAccountMeta(accounts.vaultStakerWithdrawalTicketTokenAccount),
            getAccountMeta(accounts.staker),
            getAccountMeta(accounts.stakerVrtTokenAccount),
            getAccountMeta(accounts.base),
            getAccountMeta(accounts.tokenProgram),
            getAccountMeta(accounts.systemProgram),
            getAccountMeta(accounts.burnSigner),
        ],
        programAddress,
        data: getEnqueueWithdrawalInstructionDataEncoder().encode(args),
    };
    return instruction;
}
function parseEnqueueWithdrawalInstruction(instruction) {
    if (instruction.accounts.length < 10) {
        // TODO: Coded error.
        throw new Error('Not enough accounts');
    }
    let accountIndex = 0;
    const getNextAccount = () => {
        const accountMeta = instruction.accounts[accountIndex];
        accountIndex += 1;
        return accountMeta;
    };
    const getNextOptionalAccount = () => {
        const accountMeta = getNextAccount();
        return accountMeta.address === programs_1.JITO_VAULT_PROGRAM_ADDRESS
            ? undefined
            : accountMeta;
    };
    return {
        programAddress: instruction.programAddress,
        accounts: {
            config: getNextAccount(),
            vault: getNextAccount(),
            vaultStakerWithdrawalTicket: getNextAccount(),
            vaultStakerWithdrawalTicketTokenAccount: getNextAccount(),
            staker: getNextAccount(),
            stakerVrtTokenAccount: getNextAccount(),
            base: getNextAccount(),
            tokenProgram: getNextAccount(),
            systemProgram: getNextAccount(),
            burnSigner: getNextOptionalAccount(),
        },
        data: getEnqueueWithdrawalInstructionDataDecoder().decode(instruction.data),
    };
}
//# sourceMappingURL=enqueueWithdrawal.js.map