"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.INITIALIZE_CONFIG_DISCRIMINATOR = void 0;
exports.getInitializeConfigDiscriminatorBytes = getInitializeConfigDiscriminatorBytes;
exports.getInitializeConfigInstructionDataEncoder = getInitializeConfigInstructionDataEncoder;
exports.getInitializeConfigInstructionDataDecoder = getInitializeConfigInstructionDataDecoder;
exports.getInitializeConfigInstructionDataCodec = getInitializeConfigInstructionDataCodec;
exports.getInitializeConfigInstruction = getInitializeConfigInstruction;
exports.parseInitializeConfigInstruction = parseInitializeConfigInstruction;
const web3_js_1 = require("solana2": "npm:@solana/web3.js@^2.0.0");
const programs_1 = require("../programs");
const shared_1 = require("../shared");
exports.INITIALIZE_CONFIG_DISCRIMINATOR = 0;
function getInitializeConfigDiscriminatorBytes() {
    return (0, web3_js_1.getU8Encoder)().encode(exports.INITIALIZE_CONFIG_DISCRIMINATOR);
}
function getInitializeConfigInstructionDataEncoder() {
    return (0, web3_js_1.transformEncoder)((0, web3_js_1.getStructEncoder)([
        ['discriminator', (0, web3_js_1.getU8Encoder)()],
        ['programFeeBps', (0, web3_js_1.getU16Encoder)()],
    ]), (value) => ({ ...value, discriminator: exports.INITIALIZE_CONFIG_DISCRIMINATOR }));
}
function getInitializeConfigInstructionDataDecoder() {
    return (0, web3_js_1.getStructDecoder)([
        ['discriminator', (0, web3_js_1.getU8Decoder)()],
        ['programFeeBps', (0, web3_js_1.getU16Decoder)()],
    ]);
}
function getInitializeConfigInstructionDataCodec() {
    return (0, web3_js_1.combineCodec)(getInitializeConfigInstructionDataEncoder(), getInitializeConfigInstructionDataDecoder());
}
function getInitializeConfigInstruction(input) {
    // Program address.
    const programAddress = programs_1.JITO_VAULT_PROGRAM_ADDRESS;
    // Original accounts.
    const originalAccounts = {
        config: { value: input.config ?? null, isWritable: true },
        admin: { value: input.admin ?? null, isWritable: true },
        restakingProgram: {
            value: input.restakingProgram ?? null,
            isWritable: false,
        },
        programFeeWallet: {
            value: input.programFeeWallet ?? null,
            isWritable: false,
        },
        systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    };
    const accounts = originalAccounts;
    // Original args.
    const args = { ...input };
    // Resolve default values.
    if (!accounts.systemProgram.value) {
        accounts.systemProgram.value =
            '11111111111111111111111111111111';
    }
    const getAccountMeta = (0, shared_1.getAccountMetaFactory)(programAddress, 'programId');
    const instruction = {
        accounts: [
            getAccountMeta(accounts.config),
            getAccountMeta(accounts.admin),
            getAccountMeta(accounts.restakingProgram),
            getAccountMeta(accounts.programFeeWallet),
            getAccountMeta(accounts.systemProgram),
        ],
        programAddress,
        data: getInitializeConfigInstructionDataEncoder().encode(args),
    };
    return instruction;
}
function parseInitializeConfigInstruction(instruction) {
    if (instruction.accounts.length < 5) {
        // TODO: Coded error.
        throw new Error('Not enough accounts');
    }
    let accountIndex = 0;
    const getNextAccount = () => {
        const accountMeta = instruction.accounts[accountIndex];
        accountIndex += 1;
        return accountMeta;
    };
    return {
        programAddress: instruction.programAddress,
        accounts: {
            config: getNextAccount(),
            admin: getNextAccount(),
            restakingProgram: getNextAccount(),
            programFeeWallet: getNextAccount(),
            systemProgram: getNextAccount(),
        },
        data: getInitializeConfigInstructionDataDecoder().decode(instruction.data),
    };
}
//# sourceMappingURL=initializeConfig.js.map