/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */

import {
  assertAccountExists,
  assertAccountsExist,
  combineCodec,
  decodeAccount,
  fetchEncodedAccount,
  fetchEncodedAccounts,
  getAddressDecoder,
  getAddressEncoder,
  getArrayDecoder,
  getArrayEncoder,
  getStructDecoder,
  getStructEncoder,
  getU64Decoder,
  getU64Encoder,
  getU8Decoder,
  getU8Encoder,
  type Account,
  type Address,
  type Codec,
  type Decoder,
  type EncodedAccount,
  type Encoder,
  type FetchAccountConfig,
  type FetchAccountsConfig,
  type MaybeAccount,
  type MaybeEncodedAccount,
} from "solana2";
import {
  getSlotToggleDecoder,
  getSlotToggleEncoder,
  type SlotToggle,
  type SlotToggleArgs,
} from "../types";

export type VaultNcnSlasherTicket = {
  discriminator: bigint;
  vault: Address;
  ncn: Address;
  slasher: Address;
  maxSlashablePerEpoch: bigint;
  index: bigint;
  state: SlotToggle;
  bump: number;
  reserved: Array<number>;
};

export type VaultNcnSlasherTicketArgs = {
  discriminator: number | bigint;
  vault: Address;
  ncn: Address;
  slasher: Address;
  maxSlashablePerEpoch: number | bigint;
  index: number | bigint;
  state: SlotToggleArgs;
  bump: number;
  reserved: Array<number>;
};

export function getVaultNcnSlasherTicketEncoder(): Encoder<VaultNcnSlasherTicketArgs> {
  return getStructEncoder([
    ["discriminator", getU64Encoder()],
    ["vault", getAddressEncoder()],
    ["ncn", getAddressEncoder()],
    ["slasher", getAddressEncoder()],
    ["maxSlashablePerEpoch", getU64Encoder()],
    ["index", getU64Encoder()],
    ["state", getSlotToggleEncoder()],
    ["bump", getU8Encoder()],
    ["reserved", getArrayEncoder(getU8Encoder(), { size: 263 })],
  ]);
}

export function getVaultNcnSlasherTicketDecoder(): Decoder<VaultNcnSlasherTicket> {
  return getStructDecoder([
    ["discriminator", getU64Decoder()],
    ["vault", getAddressDecoder()],
    ["ncn", getAddressDecoder()],
    ["slasher", getAddressDecoder()],
    ["maxSlashablePerEpoch", getU64Decoder()],
    ["index", getU64Decoder()],
    ["state", getSlotToggleDecoder()],
    ["bump", getU8Decoder()],
    ["reserved", getArrayDecoder(getU8Decoder(), { size: 263 })],
  ]);
}

export function getVaultNcnSlasherTicketCodec(): Codec<
  VaultNcnSlasherTicketArgs,
  VaultNcnSlasherTicket
> {
  return combineCodec(
    getVaultNcnSlasherTicketEncoder(),
    getVaultNcnSlasherTicketDecoder()
  );
}

export function decodeVaultNcnSlasherTicket<TAddress extends string = string>(
  encodedAccount: EncodedAccount<TAddress>
): Account<VaultNcnSlasherTicket, TAddress>;
export function decodeVaultNcnSlasherTicket<TAddress extends string = string>(
  encodedAccount: MaybeEncodedAccount<TAddress>
): MaybeAccount<VaultNcnSlasherTicket, TAddress>;
export function decodeVaultNcnSlasherTicket<TAddress extends string = string>(
  encodedAccount: EncodedAccount<TAddress> | MaybeEncodedAccount<TAddress>
):
  | Account<VaultNcnSlasherTicket, TAddress>
  | MaybeAccount<VaultNcnSlasherTicket, TAddress> {
  return decodeAccount(
    encodedAccount as MaybeEncodedAccount<TAddress>,
    getVaultNcnSlasherTicketDecoder()
  );
}

export async function fetchVaultNcnSlasherTicket<
  TAddress extends string = string
>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<Account<VaultNcnSlasherTicket, TAddress>> {
  const maybeAccount = await fetchMaybeVaultNcnSlasherTicket(
    rpc,
    address,
    config
  );
  assertAccountExists(maybeAccount);
  return maybeAccount;
}

export async function fetchMaybeVaultNcnSlasherTicket<
  TAddress extends string = string
>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<MaybeAccount<VaultNcnSlasherTicket, TAddress>> {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeVaultNcnSlasherTicket(maybeAccount);
}

export async function fetchAllVaultNcnSlasherTicket(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<Account<VaultNcnSlasherTicket>[]> {
  const maybeAccounts = await fetchAllMaybeVaultNcnSlasherTicket(
    rpc,
    addresses,
    config
  );
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}

export async function fetchAllMaybeVaultNcnSlasherTicket(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<MaybeAccount<VaultNcnSlasherTicket>[]> {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map((maybeAccount) =>
    decodeVaultNcnSlasherTicket(maybeAccount)
  );
}
