/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */

import {
  combineCodec,
  getStructDecoder,
  getStructEncoder,
  getU8Decoder,
  getU8Encoder,
  transformEncoder,
  type Address,
  type Codec,
  type Decoder,
  type Encoder,
  type IAccountMeta,
  type IAccountSignerMeta,
  type IInstruction,
  type IInstructionWithAccounts,
  type IInstructionWithData,
  type ReadonlyAccount,
  type ReadonlySignerAccount,
  type TransactionSigner,
  type WritableAccount,
} from "solana2";
import { JITO_VAULT_PROGRAM_ADDRESS } from "../programs";
import { getAccountMetaFactory, type ResolvedAccount } from "../shared";

export const CHANGE_WITHDRAWAL_TICKET_OWNER_DISCRIMINATOR = 13;

export function getChangeWithdrawalTicketOwnerDiscriminatorBytes() {
  return getU8Encoder().encode(CHANGE_WITHDRAWAL_TICKET_OWNER_DISCRIMINATOR);
}

export type ChangeWithdrawalTicketOwnerInstruction<
  TProgram extends string = typeof JITO_VAULT_PROGRAM_ADDRESS,
  TAccountConfig extends string | IAccountMeta<string> = string,
  TAccountVault extends string | IAccountMeta<string> = string,
  TAccountVaultStakerWithdrawalTicket extends
    | string
    | IAccountMeta<string> = string,
  TAccountOldOwner extends string | IAccountMeta<string> = string,
  TAccountNewOwner extends string | IAccountMeta<string> = string,
  TRemainingAccounts extends readonly IAccountMeta<string>[] = []
> = IInstruction<TProgram> &
  IInstructionWithData<Uint8Array> &
  IInstructionWithAccounts<
    [
      TAccountConfig extends string
        ? ReadonlyAccount<TAccountConfig>
        : TAccountConfig,
      TAccountVault extends string
        ? ReadonlyAccount<TAccountVault>
        : TAccountVault,
      TAccountVaultStakerWithdrawalTicket extends string
        ? WritableAccount<TAccountVaultStakerWithdrawalTicket>
        : TAccountVaultStakerWithdrawalTicket,
      TAccountOldOwner extends string
        ? ReadonlySignerAccount<TAccountOldOwner> &
            IAccountSignerMeta<TAccountOldOwner>
        : TAccountOldOwner,
      TAccountNewOwner extends string
        ? ReadonlyAccount<TAccountNewOwner>
        : TAccountNewOwner,
      ...TRemainingAccounts
    ]
  >;

export type ChangeWithdrawalTicketOwnerInstructionData = {
  discriminator: number;
};

export type ChangeWithdrawalTicketOwnerInstructionDataArgs = {};

export function getChangeWithdrawalTicketOwnerInstructionDataEncoder(): Encoder<ChangeWithdrawalTicketOwnerInstructionDataArgs> {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({
      ...value,
      discriminator: CHANGE_WITHDRAWAL_TICKET_OWNER_DISCRIMINATOR,
    })
  );
}

export function getChangeWithdrawalTicketOwnerInstructionDataDecoder(): Decoder<ChangeWithdrawalTicketOwnerInstructionData> {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}

export function getChangeWithdrawalTicketOwnerInstructionDataCodec(): Codec<
  ChangeWithdrawalTicketOwnerInstructionDataArgs,
  ChangeWithdrawalTicketOwnerInstructionData
> {
  return combineCodec(
    getChangeWithdrawalTicketOwnerInstructionDataEncoder(),
    getChangeWithdrawalTicketOwnerInstructionDataDecoder()
  );
}

export type ChangeWithdrawalTicketOwnerInput<
  TAccountConfig extends string = string,
  TAccountVault extends string = string,
  TAccountVaultStakerWithdrawalTicket extends string = string,
  TAccountOldOwner extends string = string,
  TAccountNewOwner extends string = string
> = {
  config: Address<TAccountConfig>;
  vault: Address<TAccountVault>;
  vaultStakerWithdrawalTicket: Address<TAccountVaultStakerWithdrawalTicket>;
  oldOwner: TransactionSigner<TAccountOldOwner>;
  newOwner: Address<TAccountNewOwner>;
};

export function getChangeWithdrawalTicketOwnerInstruction<
  TAccountConfig extends string,
  TAccountVault extends string,
  TAccountVaultStakerWithdrawalTicket extends string,
  TAccountOldOwner extends string,
  TAccountNewOwner extends string
>(
  input: ChangeWithdrawalTicketOwnerInput<
    TAccountConfig,
    TAccountVault,
    TAccountVaultStakerWithdrawalTicket,
    TAccountOldOwner,
    TAccountNewOwner
  >
): ChangeWithdrawalTicketOwnerInstruction<
  typeof JITO_VAULT_PROGRAM_ADDRESS,
  TAccountConfig,
  TAccountVault,
  TAccountVaultStakerWithdrawalTicket,
  TAccountOldOwner,
  TAccountNewOwner
> {
  // Program address.
  const programAddress = JITO_VAULT_PROGRAM_ADDRESS;

  // Original accounts.
  const originalAccounts = {
    config: { value: input.config ?? null, isWritable: false },
    vault: { value: input.vault ?? null, isWritable: false },
    vaultStakerWithdrawalTicket: {
      value: input.vaultStakerWithdrawalTicket ?? null,
      isWritable: true,
    },
    oldOwner: { value: input.oldOwner ?? null, isWritable: false },
    newOwner: { value: input.newOwner ?? null, isWritable: false },
  };
  const accounts = originalAccounts as Record<
    keyof typeof originalAccounts,
    ResolvedAccount
  >;

  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.config),
      getAccountMeta(accounts.vault),
      getAccountMeta(accounts.vaultStakerWithdrawalTicket),
      getAccountMeta(accounts.oldOwner),
      getAccountMeta(accounts.newOwner),
    ],
    programAddress,
    data: getChangeWithdrawalTicketOwnerInstructionDataEncoder().encode({}),
  } as ChangeWithdrawalTicketOwnerInstruction<
    typeof JITO_VAULT_PROGRAM_ADDRESS,
    TAccountConfig,
    TAccountVault,
    TAccountVaultStakerWithdrawalTicket,
    TAccountOldOwner,
    TAccountNewOwner
  >;

  return instruction;
}

export type ParsedChangeWithdrawalTicketOwnerInstruction<
  TProgram extends string = typeof JITO_VAULT_PROGRAM_ADDRESS,
  TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]
> = {
  programAddress: Address<TProgram>;
  accounts: {
    config: TAccountMetas[0];
    vault: TAccountMetas[1];
    vaultStakerWithdrawalTicket: TAccountMetas[2];
    oldOwner: TAccountMetas[3];
    newOwner: TAccountMetas[4];
  };
  data: ChangeWithdrawalTicketOwnerInstructionData;
};

export function parseChangeWithdrawalTicketOwnerInstruction<
  TProgram extends string,
  TAccountMetas extends readonly IAccountMeta[]
>(
  instruction: IInstruction<TProgram> &
    IInstructionWithAccounts<TAccountMetas> &
    IInstructionWithData<Uint8Array>
): ParsedChangeWithdrawalTicketOwnerInstruction<TProgram, TAccountMetas> {
  if (instruction.accounts.length < 5) {
    // TODO: Coded error.
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts![accountIndex]!;
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      config: getNextAccount(),
      vault: getNextAccount(),
      vaultStakerWithdrawalTicket: getNextAccount(),
      oldOwner: getNextAccount(),
      newOwner: getNextAccount(),
    },
    data: getChangeWithdrawalTicketOwnerInstructionDataDecoder().decode(
      instruction.data
    ),
  };
}
