/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */

import {
  combineCodec,
  getStructDecoder,
  getStructEncoder,
  getU8Decoder,
  getU8Encoder,
  transformEncoder,
  type Address,
  type Codec,
  type Decoder,
  type Encoder,
  type IAccountMeta,
  type IAccountSignerMeta,
  type IInstruction,
  type IInstructionWithAccounts,
  type IInstructionWithData,
  type ReadonlyAccount,
  type ReadonlySignerAccount,
  type TransactionSigner,
  type WritableAccount,
  type WritableSignerAccount,
} from "solana2";
import { JITO_VAULT_PROGRAM_ADDRESS } from "../programs";
import { getAccountMetaFactory, type ResolvedAccount } from "../shared";

export const INITIALIZE_VAULT_NCN_SLASHER_TICKET_DISCRIMINATOR = 6;

export function getInitializeVaultNcnSlasherTicketDiscriminatorBytes() {
  return getU8Encoder().encode(
    INITIALIZE_VAULT_NCN_SLASHER_TICKET_DISCRIMINATOR
  );
}

export type InitializeVaultNcnSlasherTicketInstruction<
  TProgram extends string = typeof JITO_VAULT_PROGRAM_ADDRESS,
  TAccountConfig extends string | IAccountMeta<string> = string,
  TAccountVault extends string | IAccountMeta<string> = string,
  TAccountNcn extends string | IAccountMeta<string> = string,
  TAccountSlasher extends string | IAccountMeta<string> = string,
  TAccountNcnSlasherTicket extends string | IAccountMeta<string> = string,
  TAccountVaultSlasherTicket extends string | IAccountMeta<string> = string,
  TAccountAdmin extends string | IAccountMeta<string> = string,
  TAccountPayer extends string | IAccountMeta<string> = string,
  TAccountSystemProgram extends
    | string
    | IAccountMeta<string> = "11111111111111111111111111111111",
  TRemainingAccounts extends readonly IAccountMeta<string>[] = []
> = IInstruction<TProgram> &
  IInstructionWithData<Uint8Array> &
  IInstructionWithAccounts<
    [
      TAccountConfig extends string
        ? ReadonlyAccount<TAccountConfig>
        : TAccountConfig,
      TAccountVault extends string
        ? ReadonlyAccount<TAccountVault>
        : TAccountVault,
      TAccountNcn extends string ? ReadonlyAccount<TAccountNcn> : TAccountNcn,
      TAccountSlasher extends string
        ? ReadonlyAccount<TAccountSlasher>
        : TAccountSlasher,
      TAccountNcnSlasherTicket extends string
        ? ReadonlyAccount<TAccountNcnSlasherTicket>
        : TAccountNcnSlasherTicket,
      TAccountVaultSlasherTicket extends string
        ? WritableAccount<TAccountVaultSlasherTicket>
        : TAccountVaultSlasherTicket,
      TAccountAdmin extends string
        ? ReadonlySignerAccount<TAccountAdmin> &
            IAccountSignerMeta<TAccountAdmin>
        : TAccountAdmin,
      TAccountPayer extends string
        ? WritableSignerAccount<TAccountPayer> &
            IAccountSignerMeta<TAccountPayer>
        : TAccountPayer,
      TAccountSystemProgram extends string
        ? ReadonlyAccount<TAccountSystemProgram>
        : TAccountSystemProgram,
      ...TRemainingAccounts
    ]
  >;

export type InitializeVaultNcnSlasherTicketInstructionData = {
  discriminator: number;
};

export type InitializeVaultNcnSlasherTicketInstructionDataArgs = {};

export function getInitializeVaultNcnSlasherTicketInstructionDataEncoder(): Encoder<InitializeVaultNcnSlasherTicketInstructionDataArgs> {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({
      ...value,
      discriminator: INITIALIZE_VAULT_NCN_SLASHER_TICKET_DISCRIMINATOR,
    })
  );
}

export function getInitializeVaultNcnSlasherTicketInstructionDataDecoder(): Decoder<InitializeVaultNcnSlasherTicketInstructionData> {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}

export function getInitializeVaultNcnSlasherTicketInstructionDataCodec(): Codec<
  InitializeVaultNcnSlasherTicketInstructionDataArgs,
  InitializeVaultNcnSlasherTicketInstructionData
> {
  return combineCodec(
    getInitializeVaultNcnSlasherTicketInstructionDataEncoder(),
    getInitializeVaultNcnSlasherTicketInstructionDataDecoder()
  );
}

export type InitializeVaultNcnSlasherTicketInput<
  TAccountConfig extends string = string,
  TAccountVault extends string = string,
  TAccountNcn extends string = string,
  TAccountSlasher extends string = string,
  TAccountNcnSlasherTicket extends string = string,
  TAccountVaultSlasherTicket extends string = string,
  TAccountAdmin extends string = string,
  TAccountPayer extends string = string,
  TAccountSystemProgram extends string = string
> = {
  config: Address<TAccountConfig>;
  vault: Address<TAccountVault>;
  ncn: Address<TAccountNcn>;
  slasher: Address<TAccountSlasher>;
  ncnSlasherTicket: Address<TAccountNcnSlasherTicket>;
  vaultSlasherTicket: Address<TAccountVaultSlasherTicket>;
  admin: TransactionSigner<TAccountAdmin>;
  payer: TransactionSigner<TAccountPayer>;
  systemProgram?: Address<TAccountSystemProgram>;
};

export function getInitializeVaultNcnSlasherTicketInstruction<
  TAccountConfig extends string,
  TAccountVault extends string,
  TAccountNcn extends string,
  TAccountSlasher extends string,
  TAccountNcnSlasherTicket extends string,
  TAccountVaultSlasherTicket extends string,
  TAccountAdmin extends string,
  TAccountPayer extends string,
  TAccountSystemProgram extends string
>(
  input: InitializeVaultNcnSlasherTicketInput<
    TAccountConfig,
    TAccountVault,
    TAccountNcn,
    TAccountSlasher,
    TAccountNcnSlasherTicket,
    TAccountVaultSlasherTicket,
    TAccountAdmin,
    TAccountPayer,
    TAccountSystemProgram
  >
): InitializeVaultNcnSlasherTicketInstruction<
  typeof JITO_VAULT_PROGRAM_ADDRESS,
  TAccountConfig,
  TAccountVault,
  TAccountNcn,
  TAccountSlasher,
  TAccountNcnSlasherTicket,
  TAccountVaultSlasherTicket,
  TAccountAdmin,
  TAccountPayer,
  TAccountSystemProgram
> {
  // Program address.
  const programAddress = JITO_VAULT_PROGRAM_ADDRESS;

  // Original accounts.
  const originalAccounts = {
    config: { value: input.config ?? null, isWritable: false },
    vault: { value: input.vault ?? null, isWritable: false },
    ncn: { value: input.ncn ?? null, isWritable: false },
    slasher: { value: input.slasher ?? null, isWritable: false },
    ncnSlasherTicket: {
      value: input.ncnSlasherTicket ?? null,
      isWritable: false,
    },
    vaultSlasherTicket: {
      value: input.vaultSlasherTicket ?? null,
      isWritable: true,
    },
    admin: { value: input.admin ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
  };
  const accounts = originalAccounts as Record<
    keyof typeof originalAccounts,
    ResolvedAccount
  >;

  // Resolve default values.
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value =
      "11111111111111111111111111111111" as Address<"11111111111111111111111111111111">;
  }

  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.config),
      getAccountMeta(accounts.vault),
      getAccountMeta(accounts.ncn),
      getAccountMeta(accounts.slasher),
      getAccountMeta(accounts.ncnSlasherTicket),
      getAccountMeta(accounts.vaultSlasherTicket),
      getAccountMeta(accounts.admin),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.systemProgram),
    ],
    programAddress,
    data: getInitializeVaultNcnSlasherTicketInstructionDataEncoder().encode({}),
  } as InitializeVaultNcnSlasherTicketInstruction<
    typeof JITO_VAULT_PROGRAM_ADDRESS,
    TAccountConfig,
    TAccountVault,
    TAccountNcn,
    TAccountSlasher,
    TAccountNcnSlasherTicket,
    TAccountVaultSlasherTicket,
    TAccountAdmin,
    TAccountPayer,
    TAccountSystemProgram
  >;

  return instruction;
}

export type ParsedInitializeVaultNcnSlasherTicketInstruction<
  TProgram extends string = typeof JITO_VAULT_PROGRAM_ADDRESS,
  TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]
> = {
  programAddress: Address<TProgram>;
  accounts: {
    config: TAccountMetas[0];
    vault: TAccountMetas[1];
    ncn: TAccountMetas[2];
    slasher: TAccountMetas[3];
    ncnSlasherTicket: TAccountMetas[4];
    vaultSlasherTicket: TAccountMetas[5];
    admin: TAccountMetas[6];
    payer: TAccountMetas[7];
    systemProgram: TAccountMetas[8];
  };
  data: InitializeVaultNcnSlasherTicketInstructionData;
};

export function parseInitializeVaultNcnSlasherTicketInstruction<
  TProgram extends string,
  TAccountMetas extends readonly IAccountMeta[]
>(
  instruction: IInstruction<TProgram> &
    IInstructionWithAccounts<TAccountMetas> &
    IInstructionWithData<Uint8Array>
): ParsedInitializeVaultNcnSlasherTicketInstruction<TProgram, TAccountMetas> {
  if (instruction.accounts.length < 9) {
    // TODO: Coded error.
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts![accountIndex]!;
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      config: getNextAccount(),
      vault: getNextAccount(),
      ncn: getNextAccount(),
      slasher: getNextAccount(),
      ncnSlasherTicket: getNextAccount(),
      vaultSlasherTicket: getNextAccount(),
      admin: getNextAccount(),
      payer: getNextAccount(),
      systemProgram: getNextAccount(),
    },
    data: getInitializeVaultNcnSlasherTicketInstructionDataDecoder().decode(
      instruction.data
    ),
  };
}
