/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */

import {
  combineCodec,
  getStructDecoder,
  getStructEncoder,
  getU8Decoder,
  getU8Encoder,
  transformEncoder,
  type Address,
  type Codec,
  type Decoder,
  type Encoder,
  type IAccountMeta,
  type IAccountSignerMeta,
  type IInstruction,
  type IInstructionWithAccounts,
  type IInstructionWithData,
  type ReadonlyAccount,
  type ReadonlySignerAccount,
  type TransactionSigner,
  type WritableAccount,
} from "solana2";
import { JITO_VAULT_PROGRAM_ADDRESS } from "../programs";
import { getAccountMetaFactory, type ResolvedAccount } from "../shared";

export const SET_CONFIG_ADMIN_DISCRIMINATOR = 31;

export function getSetConfigAdminDiscriminatorBytes() {
  return getU8Encoder().encode(SET_CONFIG_ADMIN_DISCRIMINATOR);
}

export type SetConfigAdminInstruction<
  TProgram extends string = typeof JITO_VAULT_PROGRAM_ADDRESS,
  TAccountConfig extends string | IAccountMeta<string> = string,
  TAccountOldAdmin extends string | IAccountMeta<string> = string,
  TAccountNewAdmin extends string | IAccountMeta<string> = string,
  TRemainingAccounts extends readonly IAccountMeta<string>[] = []
> = IInstruction<TProgram> &
  IInstructionWithData<Uint8Array> &
  IInstructionWithAccounts<
    [
      TAccountConfig extends string
        ? WritableAccount<TAccountConfig>
        : TAccountConfig,
      TAccountOldAdmin extends string
        ? ReadonlySignerAccount<TAccountOldAdmin> &
            IAccountSignerMeta<TAccountOldAdmin>
        : TAccountOldAdmin,
      TAccountNewAdmin extends string
        ? ReadonlyAccount<TAccountNewAdmin>
        : TAccountNewAdmin,
      ...TRemainingAccounts
    ]
  >;

export type SetConfigAdminInstructionData = { discriminator: number };

export type SetConfigAdminInstructionDataArgs = {};

export function getSetConfigAdminInstructionDataEncoder(): Encoder<SetConfigAdminInstructionDataArgs> {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: SET_CONFIG_ADMIN_DISCRIMINATOR })
  );
}

export function getSetConfigAdminInstructionDataDecoder(): Decoder<SetConfigAdminInstructionData> {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}

export function getSetConfigAdminInstructionDataCodec(): Codec<
  SetConfigAdminInstructionDataArgs,
  SetConfigAdminInstructionData
> {
  return combineCodec(
    getSetConfigAdminInstructionDataEncoder(),
    getSetConfigAdminInstructionDataDecoder()
  );
}

export type SetConfigAdminInput<
  TAccountConfig extends string = string,
  TAccountOldAdmin extends string = string,
  TAccountNewAdmin extends string = string
> = {
  config: Address<TAccountConfig>;
  oldAdmin: TransactionSigner<TAccountOldAdmin>;
  newAdmin: Address<TAccountNewAdmin>;
};

export function getSetConfigAdminInstruction<
  TAccountConfig extends string,
  TAccountOldAdmin extends string,
  TAccountNewAdmin extends string
>(
  input: SetConfigAdminInput<TAccountConfig, TAccountOldAdmin, TAccountNewAdmin>
): SetConfigAdminInstruction<
  typeof JITO_VAULT_PROGRAM_ADDRESS,
  TAccountConfig,
  TAccountOldAdmin,
  TAccountNewAdmin
> {
  // Program address.
  const programAddress = JITO_VAULT_PROGRAM_ADDRESS;

  // Original accounts.
  const originalAccounts = {
    config: { value: input.config ?? null, isWritable: true },
    oldAdmin: { value: input.oldAdmin ?? null, isWritable: false },
    newAdmin: { value: input.newAdmin ?? null, isWritable: false },
  };
  const accounts = originalAccounts as Record<
    keyof typeof originalAccounts,
    ResolvedAccount
  >;

  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.config),
      getAccountMeta(accounts.oldAdmin),
      getAccountMeta(accounts.newAdmin),
    ],
    programAddress,
    data: getSetConfigAdminInstructionDataEncoder().encode({}),
  } as SetConfigAdminInstruction<
    typeof JITO_VAULT_PROGRAM_ADDRESS,
    TAccountConfig,
    TAccountOldAdmin,
    TAccountNewAdmin
  >;

  return instruction;
}

export type ParsedSetConfigAdminInstruction<
  TProgram extends string = typeof JITO_VAULT_PROGRAM_ADDRESS,
  TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]
> = {
  programAddress: Address<TProgram>;
  accounts: {
    config: TAccountMetas[0];
    oldAdmin: TAccountMetas[1];
    newAdmin: TAccountMetas[2];
  };
  data: SetConfigAdminInstructionData;
};

export function parseSetConfigAdminInstruction<
  TProgram extends string,
  TAccountMetas extends readonly IAccountMeta[]
>(
  instruction: IInstruction<TProgram> &
    IInstructionWithAccounts<TAccountMetas> &
    IInstructionWithData<Uint8Array>
): ParsedSetConfigAdminInstruction<TProgram, TAccountMetas> {
  if (instruction.accounts.length < 3) {
    // TODO: Coded error.
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts![accountIndex]!;
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      config: getNextAccount(),
      oldAdmin: getNextAccount(),
      newAdmin: getNextAccount(),
    },
    data: getSetConfigAdminInstructionDataDecoder().decode(instruction.data),
  };
}
